#include <iostream>
#include <fstream>
#define MAXN 100003
#define MAXM 500003
#define INF 100000000
using namespace std;

int n,m,k;
int hmin,kmin;
int nr1[MAXM]; //numarul de 1 de pe fiecare coloana
int x,y;

void solve_brute() {
    /*
    Aceasta rezolvare ia in calcul toate posibilitatile de taiere a coloanelor:
        -distanta de taiere 0..k
        -punctul de inceput al taierii 1..m
    Pentru fiecare posibilitate, se calculeaza inaltimea maxima care ramane.
    Aceasta este comparata cu hmin actual. Daca valoare lui hmin este mai mare, hmin este actualizat (impreuna cu kmin).
    Datorita faptului ca distanta de taiere creste progresiv, suntem siguri ca kmin va avea cea mai mica valoare posibila.
    */
    int hmax;
    for(int kt=0; kt<=k; kt++) {//kt - lungimea bucatii taiate
        for(int i=1; i<=m-kt; i++) {//i - coloana de la care incepem sa taiem
            hmax = 0;
            for(int j=1; j<i; j++) {
                hmax = max(hmax,nr1[j]);
            }
            for(int j=i+kt; j<=m; j++) {
                hmax = max(hmax,nr1[j]);
            }
            if (hmin>hmax) {
                hmin = hmax;
                kmin = kt;
            }
        }
    }
}

int main() {
    ifstream fin("placa.in");
    ofstream fout("placa.out");
    fin>>n>>m>>k;
    for(int j=1; j<=m; j++) {
            fin>>x>>y;
            nr1[j]=x+y;
        }

    fin.close();

    hmin = INF;
    kmin = INF;

    solve_brute();

    fout<<hmin<<"\n"<<kmin<<"\n";
    fout.close();
    return 0;
}
